#include <string.h>
#include <stdlib.h>

extern "C" {

void bzero( char *, int ) ;
void bcopy( char *, char *, int ) ;
int  bcmp ( char *, char *, int ) ;

}

#if !defined(__PAGE_TABLE_H)
#define	__PAGE_TABLE_H

class PageTable 
{ 
	public :

		// Constructors and Destructors
		PageTable() ;

		// Selectors 
		int
		GetPageId(int Quadrant) ;	

		int
		Get( int Index ) ;

		int
		GetQuadrants(int PageId, int* Quadrants) ; 

		// Anabolizers 
		int
		InsertPageId(int PageId) ; 

		int
		InsertQuadrant(int PageIdId, int Quadrant) ; 
		

		int
		GetNumberOfPages() ;

		// Error Codes specific to instances of this
		// class

		static const int PAGE_ID_NOT_FOUND 		= -1 ;  		
		static const int QUADRANT_NOT_FOUND		= -2 ; 
		static const int PAGE_ID_ALREADY_EXISTS		= -5 ; 
		static const int QUADRANT_ALREADY_EXISTS	= -6 ; 

	protected :

		int
		PageIdTable[4] ;

		int  
		QuadrantTable[4][4] ; 
} ;

inline 
PageTable::PageTable()
{
	for ( int i = 0 ; i < 4 ; i++ )
	{
		PageIdTable[i] = -1 ;

		for ( int j = 0 ; j < 4 ; j++ )
		{
			QuadrantTable[i][j] = -1 ; 
		}
	}
}

#endif 
