#ifndef _QUADSORT_H_
#define _QUADSORT_H_

#include <standard.h>
#include <sys/types.h>
#include <unistd.h>

int compare(Point_t p1, Point_t p2);

const   NO_POINT        =       0 ;
const   SINGLE_POINT    =       1 ;
const   MANY_POINTS     =       2 ;

class Quadfile_t
{
private:

	int		fDesc;
	Point_t 	points[2] ;  
	Boolean		validity[2] ;
	int		curIndex ; 
	Rect_t		extent ; 

 	int incr()
	{
		Assert( curIndex == 0 || curIndex == 1 ) ;
		return curIndex = (curIndex == 0 ? 1 : 0) ;
	}

	int next()
	{
		Assert( curIndex == 0 || curIndex == 1 ) ;
		return curIndex == 0 ? 1 : 0 ;
	}

	int curr()
	{
		Assert( curIndex == 0 || curIndex == 1 ) ;
		return curIndex ;
	}

	Boolean isValid(int index)
	{
		Assert ( index == 0 || index == 1 ) ;
		return validity[index] ;
	}

	void setValid( int index )
	{
		Assert ( index == 0 || index == 1 ) ;
		validity[index] = True ;
	}
		
	void setNonValid( int index )
	{
		Assert ( index == 0 || index == 1 ) ;
		validity[index] = False ;
	}
		
public:
	
	Quadfile_t(char *fName);
	virtual ~Quadfile_t();

	void setExtent( Rect_t wextent )
	{
		extent = wextent ;
	}
		
	int Get(Point_t& pt) ;  
	int peek(Point_t pt) ;
};          

#endif
